#ifndef PSF_BINARY_SERIALIZER_HPP
#define PSF_BINARY_SERIALIZER_HPP

#include "Serializer.hpp"

namespace PSF
{
	class CBinarySerializer : public ISerializer
	{
	public:
		CBinarySerializer( std::ostream& i_ostream);
		virtual ~CBinarySerializer();
		virtual void Serialize( const int& i_in);
		virtual void Serialize( const unsigned int& i_in);
		virtual void Serialize( const bool& i_in);
		virtual void Serialize( const char& i_in);
		virtual void Serialize( const unsigned char& i_in);
		virtual void Serialize( const short& i_in);
		virtual void Serialize( const unsigned short& i_in);
		virtual void Serialize( const long& i_in);
		virtual void Serialize( const unsigned long& i_in);
		virtual void Serialize( const float& i_in);
		virtual void Serialize( const double& i_in);
		// same as double
		// virtual void Serialize( const long double& i_in);
		virtual void Serialize( const wchar_t& i_in);

		virtual std::auto_ptr<ISerializer> SerializeCompound( const std::wstring& i_wstrName, const Loki::TypeInfo& i_type);
		virtual std::auto_ptr<ISerializer> SerializeRange( const std::wstring& i_wstrName, const Loki::TypeInfo& i_type);
	protected:
		std::ostream& m_ostream;
		size_t m_nStartPos;
	};
};

#endif