#include "Checker.hpp"
#include "assert.hpp"
#include <stdexcept>

////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
PSF::CCheckerNull::~CCheckerNull()
{
}

void PSF::CCheckerNull::TypeMissing() const
{
}

void PSF::CCheckerNull::TypeMismatch() const
{
}

void PSF::CCheckerNull::TypeUnknown() const
{
}

void PSF::CCheckerNull::SematicError() const
{
}

void PSF::CCheckerNull::RangeSizeError() const
{
}

////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
PSF::CCheckerAssert::~CCheckerAssert()
{
}

void PSF::CCheckerAssert::TypeMissing() const
{
    PSF_ASSERT(false);
}

void PSF::CCheckerAssert::TypeMismatch() const
{
    PSF_ASSERT(false);
}

void PSF::CCheckerAssert::TypeUnknown() const
{
    PSF_ASSERT(false);
}

void PSF::CCheckerAssert::SematicError() const
{
    PSF_ASSERT(false);
}

void PSF::CCheckerAssert::RangeSizeError() const
{
    PSF_ASSERT(false);
}

////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
PSF::CCheckerException::~CCheckerException()
{
}

void PSF::CCheckerException::TypeMissing() const
{
	throw std::runtime_error( "Type missing");
}

void PSF::CCheckerException::TypeMismatch() const
{
	throw std::runtime_error( "Type mismath");
}

void PSF::CCheckerException::TypeUnknown() const
{
	throw std::runtime_error( "Type unknown");
}

void PSF::CCheckerException::SematicError() const
{
	throw std::runtime_error( "Sematic error");
}

void PSF::CCheckerException::RangeSizeError() const
{
	throw std::runtime_error( "Range size error");
}
