#include "DeSerialize.hpp"

#ifndef PSF_PARTIAL_ORDERING_OF_TEMPLATES

// POD DeSerializers
bool PSF::DeSerialize( char& o_out, IDeSerializer& i_deserializer)
{
	return i_deserializer.DeSerialize( o_out);
}

bool PSF::DeSerialize( unsigned char& o_out, IDeSerializer& i_deserializer)
{
	return i_deserializer.DeSerialize( o_out);
}

bool PSF::DeSerialize( short& o_out, IDeSerializer& i_deserializer)
{
	return i_deserializer.DeSerialize( o_out);
}

bool PSF::DeSerialize( unsigned short& o_out, IDeSerializer& i_deserializer)
{
	return i_deserializer.DeSerialize( o_out);
}

bool PSF::DeSerialize( int& o_out, IDeSerializer& i_deserializer)
{
	return i_deserializer.DeSerialize( o_out);
}

bool PSF::DeSerialize( unsigned int& o_out, IDeSerializer& i_deserializer)
{
	return i_deserializer.DeSerialize( o_out);
}

bool PSF::DeSerialize( long& o_out, IDeSerializer& i_deserializer)
{
	return i_deserializer.DeSerialize( o_out);
}

bool PSF::DeSerialize( unsigned long& o_out, IDeSerializer& i_deserializer)
{
	return i_deserializer.DeSerialize( o_out);
}

bool PSF::DeSerialize( float& o_out, IDeSerializer& i_deserializer)
{
	return i_deserializer.DeSerialize( o_out);
}

bool PSF::DeSerialize( double& o_out, IDeSerializer& i_deserializer)
{
	return i_deserializer.DeSerialize( o_out);
}

bool PSF::DeSerialize( bool& o_out, IDeSerializer& i_deserializer)
{
	return i_deserializer.DeSerialize( o_out);
}

bool PSF::DeSerialize( wchar_t& o_out, IDeSerializer& i_deserializer)
{
	return i_deserializer.DeSerialize( o_out);
}



bool PSF::DeSerialize( char& o_out, IDeSerializer& i_deserializer, const std::wstring& i_wstrName)
{
	std::auto_ptr<IDeSerializer> pDeSerializer( i_deserializer.DeSerializeCompound( i_wstrName, Loki::TypeInfo(typeid(char))));
	if ( !pDeSerializer.get()) return false;

	return DeSerialize( o_out, *pDeSerializer);
}

bool PSF::DeSerialize( unsigned char& o_out, IDeSerializer& i_deserializer, const std::wstring& i_wstrName)
{
	std::auto_ptr<IDeSerializer> pDeSerializer( i_deserializer.DeSerializeCompound( i_wstrName, Loki::TypeInfo(typeid(unsigned char))));
	if ( !pDeSerializer.get()) return false;

	return DeSerialize( o_out, *pDeSerializer);
}

bool PSF::DeSerialize( short& o_out, IDeSerializer& i_deserializer, const std::wstring& i_wstrName)
{
	std::auto_ptr<IDeSerializer> pDeSerializer( i_deserializer.DeSerializeCompound( i_wstrName, Loki::TypeInfo(typeid(short))));
	if ( !pDeSerializer.get()) return false;

	return DeSerialize( o_out, *pDeSerializer);
}

bool PSF::DeSerialize( unsigned short& o_out, IDeSerializer& i_deserializer, const std::wstring& i_wstrName)
{
	std::auto_ptr<IDeSerializer> pDeSerializer( i_deserializer.DeSerializeCompound( i_wstrName, Loki::TypeInfo(typeid(unsigned short))));
	if ( !pDeSerializer.get()) return false;

	return DeSerialize( o_out, *pDeSerializer);
}

bool PSF::DeSerialize( int& o_out, IDeSerializer& i_deserializer, const std::wstring& i_wstrName)
{
	std::auto_ptr<IDeSerializer> pDeSerializer( i_deserializer.DeSerializeCompound( i_wstrName, Loki::TypeInfo(typeid(int))));
	if ( !pDeSerializer.get()) return false;

	return DeSerialize( o_out, *pDeSerializer);
}

bool PSF::DeSerialize( unsigned int& o_out, IDeSerializer& i_deserializer, const std::wstring& i_wstrName)
{
	std::auto_ptr<IDeSerializer> pDeSerializer( i_deserializer.DeSerializeCompound( i_wstrName, Loki::TypeInfo(typeid(unsigned int))));
	if ( !pDeSerializer.get()) return false;

	return DeSerialize( o_out, *pDeSerializer);
}

bool PSF::DeSerialize( long& o_out, IDeSerializer& i_deserializer, const std::wstring& i_wstrName)
{
	std::auto_ptr<IDeSerializer> pDeSerializer( i_deserializer.DeSerializeCompound( i_wstrName, Loki::TypeInfo(typeid(long))));
	if ( !pDeSerializer.get()) return false;

	return DeSerialize( o_out, *pDeSerializer);
}

bool PSF::DeSerialize( unsigned long& o_out, IDeSerializer& i_deserializer, const std::wstring& i_wstrName)
{
	std::auto_ptr<IDeSerializer> pDeSerializer( i_deserializer.DeSerializeCompound( i_wstrName, Loki::TypeInfo(typeid(unsigned long))));
	if ( !pDeSerializer.get()) return false;

	return DeSerialize( o_out, *pDeSerializer);
}

bool PSF::DeSerialize( float& o_out, IDeSerializer& i_deserializer, const std::wstring& i_wstrName)
{
	std::auto_ptr<IDeSerializer> pDeSerializer( i_deserializer.DeSerializeCompound( i_wstrName, Loki::TypeInfo(typeid(float))));
	if ( !pDeSerializer.get()) return false;

	return DeSerialize( o_out, *pDeSerializer);
}

bool PSF::DeSerialize( double& o_out, IDeSerializer& i_deserializer, const std::wstring& i_wstrName)
{
	std::auto_ptr<IDeSerializer> pDeSerializer( i_deserializer.DeSerializeCompound( i_wstrName, Loki::TypeInfo(typeid(double))));
	if ( !pDeSerializer.get()) return false;

	return DeSerialize( o_out, *pDeSerializer);
}

bool PSF::DeSerialize( bool& o_out, IDeSerializer& i_deserializer, const std::wstring& i_wstrName)
{
	std::auto_ptr<IDeSerializer> pDeSerializer( i_deserializer.DeSerializeCompound( i_wstrName, Loki::TypeInfo(typeid(bool))));
	if ( !pDeSerializer.get()) return false;

	return DeSerialize( o_out, *pDeSerializer);
}

bool PSF::DeSerialize( wchar_t& o_out, IDeSerializer& i_deserializer, const std::wstring& i_wstrName)
{
	std::auto_ptr<IDeSerializer> pDeSerializer( i_deserializer.DeSerializeCompound( i_wstrName, Loki::TypeInfo(typeid(wchar_t))));
	if ( !pDeSerializer.get()) return false;

	return DeSerialize( o_out, *pDeSerializer);
}
#endif